/*
 * Copyright (c) 2006, Your Corporation. All Rights Reserved.
 */

package cr311h3;

import gui.ClosableJFrame;
import gui.run.RunMenu;
import gui.run.RunMenuBar;
import gui.run.RunMenuItem;
import j2d.ImageUtils;
import j2d.Images;
import j2d.gui.ImagePanel;

import javax.swing.*;
import java.awt.*;
import java.io.File;

// Added import stqatements for printing 2/14/2006
import javax.print.PrintService;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Feb 6, 2006
 * Time: 4:05:54 PM
 */
//todo for hw3 students who are late with their hw, print all the images
// in the catalog on multiple pages (using my solution, if you want).
// This is due by Wednesday (i.e., before thursday).
public class ImageCatalog2 {
    Container c = null;

    //Added jPanelArray and jPanelIndex variables 2-15-2006
    static JPanel jPanelArray[];
    int jPanelIndex = 0;

    public RunMenu getFileMenu() {
        RunMenu fileMenu = new RunMenu("[File");

        fileMenu.add(new RunMenuItem("[quit{control q}") {
            public void run() {
                System.exit(0);
            }
        });
        fileMenu.add(new RunMenuItem("[Print catalog{control p}") {
            public void run() {
                //ImageCatalog.this.print();
                PrintImageCatalog.print();
            }
        });
        return fileMenu;
    }

    //todo this is implemented for hw3
    //1. Add a file menu to the print catalog frame.
    //2. Add a print menu to the file menu.
    //3. Implement the print menu using
    //    ImageUtils.print(Component c, String title)
    // Don't forget to set your margins so that you have
    // 1 inch borders.
    private void printCatalog() {
        if (c == null) return;
        ImageUtils.print(c, "catalog");
    }

    private JMenuBar getMenuBar() {
        RunMenuBar jm = new RunMenuBar();
        jm.add(getFileMenu());
        return jm;
    }

    public static JPanel getWhitePanel(final int w, final int h) {
        JPanel jp = new JPanel() {
            public Dimension getPreferredSize() {
                return new Dimension(w, h);
            }
        };
        jp.setBackground(Color.WHITE);
        return jp;
    }

    public void appendImages(ImageBrowser imageBrowser, File[] imageFiles) {
        //added to calculate number of pages and set array size 2-15-2006
        double numOfPages = Math.rint(imageFiles.length / 60.0);
        jPanelArray = new JPanel[(int) numOfPages];

        for (int i = 0; i < imageFiles.length; i = i + 60)
            appendImages(imageBrowser, imageFiles, i);
    }

    private void appendImages(ImageBrowser imageBrowser, File[] imageFiles, int startImage) {
        Images imgs = imageBrowser.getImages();
        ClosableJFrame cf = new ClosableJFrame();

        cf.setJMenuBar(getMenuBar());
        c = cf.getContentPane();
        c.setLayout(new BorderLayout());

        //Modified JPanel to create an array of JPanels 2-15-2006
        jPanelArray[jPanelIndex] = new JPanel();
        jPanelArray[jPanelIndex].setBackground(Color.WHITE);
        //JPanel sp = new JPanel();
        //sp.setBackground(Color.WHITE);
        //sp.add(getCompositeImagePanel(imgs.getImages(), imageFiles, startImage));

        //cArray[cPanelIndex].add(sp);
        jPanelArray[jPanelIndex].add(getCompositeImagePanel(imgs.getImages(), imageFiles, startImage));

        c.add(getWhitePanel(560, 70), BorderLayout.NORTH);
        c.add(getWhitePanel(70, 700), BorderLayout.WEST);
        c.add(getWhitePanel(70, 700), BorderLayout.EAST);
        c.add(getWhitePanel(560, 70), BorderLayout.SOUTH);
        //c.add(sp, BorderLayout.CENTER);

        c.add(jPanelArray[jPanelIndex], BorderLayout.CENTER);

        //index JPanel array
        if (jPanelIndex < jPanelArray.length - 1)
            jPanelIndex++;
        System.out.println("cpanelIndex = " + jPanelIndex);

        //c.add(sp, BorderLayout.CENTER);
        // 70 ppi
        // 8x10 inches comes to
        // wxh of 560,700
        cf.setSize(630, 770);
        cf.setVisible(true);

        //print(c);
        //Dimension d = new Dimension(100,100);
        //Image image = imgs.getImage(d,6,8);
        //ImageUtils.displayImage(image,"compositeImage");
    }

    private JPanel getCompositeImagePanel(Image[] img, File[] imageFiles, int startImage) {
        int numberOfImages = 60 + startImage;
        final int size = 50;

        JPanel compositeImagePanel = new JPanel();
        compositeImagePanel.setBackground(Color.WHITE);
        compositeImagePanel.setLayout(new GridLayout(0, 6));

        for (int i = startImage; i < numberOfImages; i++) {
            if (i >= img.length) break;
            JPanel jp = new JPanel();
            jp.setBackground(Color.WHITE);
            jp.setLayout(new BorderLayout());
            ImagePanel ip = new ImagePanel() {
                public Dimension getPreferredSize() {
                    return new Dimension(size, size);
                }
            };
            ip.setSize(size, size);
            ip.setLayout(new FlowLayout());
            ip.setImage(ImageUtils.scaleFast(img[i], size, size));
            ip.setPreferredSize(new Dimension(size, size));
            jp.add(ip, BorderLayout.CENTER);
            JLabel jl = new JLabel(imageFiles[i].getName());
            jl.setFont(new Font("times", Font.ITALIC, 10));
            jp.add(jl, BorderLayout.SOUTH);
            compositeImagePanel.add(jp);
        }
        return compositeImagePanel;
    }

    private static void print(Container c) {
        ImageUtils.print(c, "catalog");
    }

    // Added class to implement printing 2-15-2006
    static class PrintImageCatalog implements Printable {
        private static Container containerArray[];

        public PrintImageCatalog(Container c[]) {
            this.containerArray = c;
            System.out.println("JPanelArray has" + c.length + " elements");
        }

        public static JPanel getWhitePanel(final int w, final int h) {
            JPanel jp = new JPanel() {
                public Dimension getPreferredSize() {
                    return new Dimension(w, h);
                }
            };
            jp.setBackground(Color.WHITE);
            return jp;
        }

        public static void print() {
            PrinterJob printerJob = PrinterJob.getPrinterJob();
            PrintService[] printService = PrinterJob.lookupPrintServices();
            for (int i = 0; i < printService.length; i++) {
                System.out.println(printService[i].getName());
            }
            PageFormat pageFormat = printerJob.defaultPage();
            if (printerJob.printDialog()) {
                printerJob.setPrintable(new PrintImageCatalog(ImageCatalog2.jPanelArray), pageFormat);
                // The 2nd param is necessary for printing into
                // a label width a right landscape format.
                try {
                    printerJob.print();
                } catch (PrinterException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
            }
        }

        public int print(Graphics graphics, PageFormat pf, int pageIndex)
                throws PrinterException {
            if (pageIndex < containerArray.length) {
                Graphics2D g2d = (Graphics2D) graphics;
                System.out.println("printing page number:" + pageIndex);
                double imageableWidth = pf.getImageableWidth();
                double imageableHeight = pf.getImageableHeight();
                g2d.translate((int) pf.getImageableX(), (int) pf.getImageableY());
                System.out.println("pf.getOrientation()=" + pf.getOrientation());
                if (pf.getOrientation() == PageFormat.LANDSCAPE) {
                    g2d.rotate(90 * Math.PI / 180, pf.getWidth() / 2, pf.getHeight() / 2);
                }
                Container container = containerArray[pageIndex];
                container.setSize((int) imageableWidth, (int) imageableHeight);
                container.setVisible(true);
                System.out.println("wxh=" + imageableWidth + " " + imageableHeight);
                System.out.println("location:" + (int) pf.getImageableX() + " " + (int) pf.getImageableY());
                ClosableJFrame cf = new ClosableJFrame();
                cf.getContentPane().add(container);
                cf.setSize(container.getSize());
                cf.setVisible(true);
                container.printAll(graphics);

                return PAGE_EXISTS;
            } else
                return NO_SUCH_PAGE;
        }
    }
}
