package security;

import utils.CompactJava;
import xml.Utils;

import java.io.File;
import java.io.Serializable;
import java.security.KeyStore;
import java.util.prefs.Preferences;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Feb 16, 2006
 * Time: 5:38:23 PM
 */
public class KeyStoreBean implements Serializable {
    private String keyStorePassword = "";
    protected String vendor = "";
    protected String keyStoreFile = "";
    protected String jarFileName = "";
    protected String alias = "";
    private static final String key = "KeyStoreBean";

    public String getVendor() {
        return vendor;
    }

    public void setVendor(String vendor) {
        this.vendor = vendor;
    }

    public String getJarFileName() {
        return jarFileName;
    }

    public void setJarFileName(String jarFileName) {
        this.jarFileName = jarFileName;
    }

    public String getAlias() {
        return alias;
    }

    public String getKeyStoreFile() {
        return keyStoreFile;
    }

    public void setKeyStoreFile(String keyStoreFile) {
        this.keyStoreFile = keyStoreFile;
    }

    public String getKeyStorePassword() {
        return keyStorePassword;
    }

    public void setKeyStorePassword(String keyStorePassword) {
        this.keyStorePassword = keyStorePassword;
    }

    public static KeyStoreBean fromXml(String xmlString) {
        return (KeyStoreBean) Utils.decodeXml(xmlString);
    }

    public String toXml() {
        return CompactJava.toXml(this) + "</java>";
    }

    public static KeyStoreBean getDefaultKeyStoreBean() {
        KeyStoreBean b = new KeyStoreBean();
        File ksf = KeyUtils.getKeystoreFile();
        b.setKeyStoreFile(ksf.toString());
        KeyStore ks = KeyUtils.getKeyStore(ksf, b.getKeyStorePassword());
        b.setAlias(KeyUtils.getAlias(ks));
        b.setVendor("DocJava, Inc.");
        return b;
    }

    public static KeyStoreBean getFromPreferences() {
        Preferences p = Preferences.userRoot();
        String s = p.get(key, null);
        if (s == null) return
                KeyStoreBean.getDefaultKeyStoreBean();
        return fromXml(s);
    }

    public boolean isValid() {
        File f = new File(keyStoreFile);
        if (!f.canRead())
            return false;
        return true;
    }

    public String toString() {
        return
                "\nvendor=" +
                        vendor +
                        "\nkeyStoreFile=" +
                        keyStoreFile +
                        "\njarFileName=" +
                        jarFileName +
                        "\nalias=" +
                        alias;
    }

    public void setAlias(String alias) {
        this.alias = alias;
    }
}
